package goodstor

import (
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/blobstor/allocator"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/blobstor/common"
)

func (s *Storage) Delete(prm common.DeletePrm) (common.DeleteRes, error) {
	if s.readOnly {
		return common.DeleteRes{}, common.ErrReadOnly
	}

	if prm.StorageID == nil {
		return common.DeleteRes{}, errNotImplemented
	}

	offset, length, err := parseStorageID(prm.StorageID)
	if err != nil {
		return common.DeleteRes{}, err
	}

	s.allocMtx.Lock()
	r := allocator.NewRegion(offset, (length+s.blockSize-1)/s.blockSize)
	err = s.allocator.Free(r)
	s.allocMtx.Unlock()
	return common.DeleteRes{}, err
}
