package uringstor

import (
	"context"

	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/blobstor/common"
)

func (s *Storage) Exists(_ context.Context, prm common.ExistsPrm) (common.ExistsRes, error) {
	if prm.StorageID == nil {
		return common.ExistsRes{}, errNotImplemented
	}

	slabID, offset, err := parseStorageID(prm.StorageID)
	if err != nil {
		return common.ExistsRes{}, err
	}

	s.slabMtx.RLock()
	ss, ok := s.slabMap[slabID]
	s.slabMtx.RUnlock()

	if !ok {
		return common.ExistsRes{}, nil
	}

	exists, err := ss.Exists(offset)
	return common.ExistsRes{Exists: exists}, err
}
