package util

import (
	"git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object"
)

// MergeSplitInfo ignores conflicts and rewrites `to` with non empty values
// from `from`.
func MergeSplitInfo(from, to *object.SplitInfo) *object.SplitInfo {
	to.SetSplitID(from.SplitID()) // overwrite SplitID and ignore conflicts

	if lp, ok := from.LastPart(); ok {
		to.SetLastPart(lp)
	}

	if link, ok := from.Link(); ok {
		to.SetLink(link)
	}

	return to
}
